package ProductApp;


/**
* ProductApp/ProductPOA.java .
* Generated by the IDL-to-Java compiler (portable), version "3.2"
* from ProductApp.idl
* Friday, April 21, 2017 9:43:36 PM PET
*/

public abstract class ProductPOA extends org.omg.PortableServer.Servant
 implements ProductApp.ProductOperations, org.omg.CORBA.portable.InvokeHandler
{

  // Constructors

  private static java.util.Hashtable _methods = new java.util.Hashtable ();
  static
  {
    _methods.put ("listProducts", new java.lang.Integer (0));
    _methods.put ("listCategories", new java.lang.Integer (1));
    _methods.put ("eliminateProduct", new java.lang.Integer (2));
    _methods.put ("returnProduct", new java.lang.Integer (3));
    _methods.put ("updateInformation", new java.lang.Integer (4));
    _methods.put ("shutdown", new java.lang.Integer (5));
  }

  public org.omg.CORBA.portable.OutputStream _invoke (String $method,
                                org.omg.CORBA.portable.InputStream in,
                                org.omg.CORBA.portable.ResponseHandler $rh)
  {
    org.omg.CORBA.portable.OutputStream out = null;
    java.lang.Integer __method = (java.lang.Integer)_methods.get ($method);
    if (__method == null)
      throw new org.omg.CORBA.BAD_OPERATION (0, org.omg.CORBA.CompletionStatus.COMPLETED_MAYBE);

    switch (__method.intValue ())
    {
       case 0:  // ProductApp/Product/listProducts
       {
         String category = in.read_wstring ();
         String $result = null;
         $result = this.listProducts (category);
         out = $rh.createReply();
         out.write_wstring ($result);
         break;
       }

       case 1:  // ProductApp/Product/listCategories
       {
         String $result = null;
         $result = this.listCategories ();
         out = $rh.createReply();
         out.write_wstring ($result);
         break;
       }

       case 2:  // ProductApp/Product/eliminateProduct
       {
         String code = in.read_wstring ();
         boolean $result = false;
         $result = this.eliminateProduct (code);
         out = $rh.createReply();
         out.write_boolean ($result);
         break;
       }

       case 3:  // ProductApp/Product/returnProduct
       {
         String code = in.read_wstring ();
         String $result = null;
         $result = this.returnProduct (code);
         out = $rh.createReply();
         out.write_wstring ($result);
         break;
       }

       case 4:  // ProductApp/Product/updateInformation
       {
         String code = in.read_wstring ();
         String description = in.read_wstring ();
         String codeCategory = in.read_wstring ();
         String price = in.read_wstring ();
         String stock = in.read_wstring ();
         boolean $result = false;
         $result = this.updateInformation (code, description, codeCategory, price, stock);
         out = $rh.createReply();
         out.write_boolean ($result);
         break;
       }

       case 5:  // ProductApp/Product/shutdown
       {
         this.shutdown ();
         out = $rh.createReply();
         break;
       }

       default:
         throw new org.omg.CORBA.BAD_OPERATION (0, org.omg.CORBA.CompletionStatus.COMPLETED_MAYBE);
    }

    return out;
  } // _invoke

  // Type-specific CORBA::Object operations
  private static String[] __ids = {
    "IDL:ProductApp/Product:1.0"};

  public String[] _all_interfaces (org.omg.PortableServer.POA poa, byte[] objectId)
  {
    return (String[])__ids.clone ();
  }

  public Product _this() 
  {
    return ProductHelper.narrow(
    super._this_object());
  }

  public Product _this(org.omg.CORBA.ORB orb) 
  {
    return ProductHelper.narrow(
    super._this_object(orb));
  }


} // class ProductPOA
